#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import time, os, sys, os.path as osp
BASE_DIR = osp.dirname( osp.dirname( __file__ ) )
sys.path[:0] = [ osp.join( BASE_DIR, "build", "lib" ) ]

import drmaa

def main():
#	example_i()
#	example_ii()
	example_iii()

def example_i():
	session = drmaa.Session()
	factor = session.job_template( "factor", 10000000000000037 )
	job = factor.run()
	job.wait()

def example_ii():
	session = drmaa.Session()
	sleep = session.job_template( "sleep", 5 )
	worker = session.job_template( "factor", 10000000000000037 )
	worker.output_path = "%s/out" % drmaa.PLACEHOLDER_WD
	worker.wd = os.getcwd()
	for jt in [ sleep, worker ]:
		job = jt.run()
		stat = job.wait()
		print stat
	file("out").read()

def example_iii():
	session = drmaa.Session()
	hour_sleep = session.job_template( "sleep", 3600 )
	job = hour_sleep.run()
	print_( "after submit:", job.state() )
	job.wait_for_state( "running" )
	#time.sleep( 2 )
	print_( "before suspend:", job.state() )
	job.suspend()
	time.sleep( 1 )
	print_( "after suspend:", job.state() )
	job.resume()
	time.sleep( 1 )
	print_( "after resume:", job.state() )
	job.terminate()
	print_( "termination status:", job.wait() )

	
def print_( *args, **kw ):
	newline = kw.get( "newline", True )
	line = " ".join( map( str, args ) )
	if newline:
		line += "\n"
	line = "\033[00;01;31m"+line+"\033[00m"
	sys.stdout.write( line )
	sys.stdout.flush()


if __name__=="__main__":
	main()

