#!/usr/bin/env python

import sys, os.path as osp

BASE_DIR = osp.dirname( __file__ )
sys.path[:0] = [ osp.join( BASE_DIR, "build", "lib" ) ]

import unittest
import testing

import drmaa
from drmaa.testsuite import drmaa_testsuite, pbs_tests
from testing import utils

def main():
	loader = unittest.TestLoader()
	modules = [ drmaa_testsuite ]
	if any( [drm.find("PBS") >= 0 for drm in drmaa.DRM_system() ] ):
		modules.append( pbs_tests )
	suite = unittest.TestSuite( map( loader.loadTestsFromModule, modules ) )
	utils.unbuffered_stdout()
	testing.main(
			testsuite = suite, #drmaa_testsuite.testsuite(),
			prog = "testsuite.py",
			description = "DRMAA testsuite",
			)

if __name__ == "__main__":
	main()

